<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 9</title>
    <link rel="stylesheet" href="style9.css">
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Inter:wght@200&family=Slabo+27px&display=swap"
        rel="stylesheet">
</head>
<body>
    <div class="container">
        <div class="rectangle3"></div>
        <div class="rectangle1"></div>
        <div class="group2">Teanologi</div>
        <div class="group1">
            <h1 id="text1">Contact</h1>
            <h2 id="text1">Product</h2>
            <h4 id="text1">About Us</h4>
            <h5 id="text1">Home</h5>
        </div>
        <div class="rectangle5"></div>
        <div class="rectangle4"></div>
        <h6 id="homemade">Home Made</h6>
        <p id="kamus">Kamus Bahasa Inggris Indonesia ini merupakan Kamus Online yang dibuat untuk memudahkan pencarian,
            penggunaan dan pembacaan arti kata.</p>
        <div class="rectangle6">
            <p id="header2">Pilihan dari yang Terbaik</p>
            <p id="name1">Stevia</p>
            <p id="name2">Chamomile</p>
            <p id="name3">Teh Hijau</p>
            <p id="name4">Hibiscus</p>
            <div class="group3">
                <div class="ellipseStevia"></div>
                <p id="Stevia">Stevia adalah sebuah genus dari sekitar 240 spesies dari ramuan dan semak dalam keluarga
                    bunga matahari, asli subtropis dan daerah tropis dari barat Amerika Utara ke Amerika Selatan.</p>
            </div>
            <div class="group4">
                <div class="ellipseChamomile"></div>
                <p id="Chamomile">Chamomile adalah tumbuhan semusim dari keluarga bunga Matahari Asteraceae. Tanaman ini
                    tumbuh di seluruh wilayah Eropa, wilayah Asia yang memiliki 4 musim. Kamomil juga telah tersebar
                    luas di Amerika Utara dan Australia oleh manusia.</p>
            </div>
            <div class="group5">
                <div class="ellipseTeh"></div>
                <p id="Teh">Teh hijau adalah nama teh yang dibuat dari daun tanaman teh yang dipetik dan mengalami
                    proses pemanasan untuk mencegah oksidasi, atau bisa juga berarti minuman yang dihasilkan dari
                    menyeduh daun teh tersebut.</p>
            </div>
            <div class="group6">
                <div class="ellipseHibiscus"></div>
                <p id="Hibiscus">Teh kembang sepatu adalah teh herbal yang dibuat sebagai infus dari kelopak bunga
                    rosella berwarna merah tua atau magenta. Itu dikonsumsi baik panas maupun dingin. </p>
            </div>
        </div>
        <div class="rectangle7">
            <div class="saleoff">45 % OFF In Appril 2022</div>
            <div class="coupon">Get your coupon and enjoy the discount. terms and Conditions applyu</div>
            <div class="group7">
                <div class="contact">Contact now</div>
                <div class="rectangle9"></div>
            </div>
        </div>
        <div class="rectangle8"></div>
        <div class="rectangle10"></div>
        <form action="" id="formInput">
            <div class="rectangle11">
                <div class="rectangle15">
                    <label for="rectangle15">NAME</label>
                    <input type="text" class="form-control" placeholder="Enter name" id="input-name">
                </div>
                <div class="bigcontact">CONTACT</div>
                <div class="rectangle12">
                    <label for="rectangle15">Email</label>
                    <input type="email" class="form-control" placeholder="Enter email" id="input-email">
                </div>
                <div class="rectangle13">
                    <label for="rectangle13">Message</label>
                    <input type="text" class="form-control" placeholder="Enter message" id="input-message">
                </div>
                <div class="rectangle14">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
            </div>
        </form>
        <footer>
            <div class="group8">Teanologi</div>
            <div class="group10">
                <img src="image/facebook.png" id="facebook">
                <img src="image/instagram.png" id="instagram">
                <img src="image/twitter.png" id="twitter">
            </div>
            <div class="group9">
                <h1 id="text1">Contact</h1>
                <h2 id="text1">Product</h2>
                <h4 id="text1">About Us</h4>
                <h5 id="text1">Home</h5>
            </div>
        </footer>
    </div>

    <script>
        //Vùng 1: Khai báo biến global
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    
        var gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
        const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    
        var submitForm = document.getElementById("formInput");
        
        //Vùng 3: Khai báo các hàm xử lý sự kiện
        submitForm.addEventListener(
            "submit", (e) => {
                // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
                e.preventDefault();
                var vUserObject = {
                    name: "",
                    emai: "",
                    message: "",
                    createDate: ""
                }
                getDataFromForm(vUserObject);
                var vValidate = validateData(vUserObject);
                if (vValidate == true) {
                    // Gọi API
                    var vXmlHttpContact = new XMLHttpRequest();
                    callContactAPI(vXmlHttpContact, vUserObject)
                    vXmlHttpContact.onreadystatechange =
                        function () {
                            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                                // Xử lý kết quả trả về
                                xuLyKetQuaTraVe(vXmlHttpContact);
                            }
                        }
                }
            }
        );
        
    
        //Vùng 4: Định nghĩa các hàm dùng chung
        // Lấy dữ liệu
        function getDataFromForm(paramUserObject) {
            var vNameElement = document.getElementById("input-name");
            var vEmailElement = document.getElementById("input-email");
            var vMessageElement = document.getElementById("input-message");
            paramUserObject.name = vNameElement.value;
            paramUserObject.email = vEmailElement.value;
            paramUserObject.message = vMessageElement.value;
        }
        // Kiểm tra dữ liệu
        function validateData(paramUserObject) {
            if (validateEmail(paramUserObject.email) == false) {
                alert("Bạn nhập sai email!");
                return false;
            }
            return true;
        }
        // Kiểm tra email
        function validateEmail(mail) {
            if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
                return (true);
            }
            return (false)
        }

        // Gọi API
        function callContactAPI(paramXMLHttpRequest, paramUserObject) {
            paramXMLHttpRequest.open("POST", gBASE_URL_CONTACTS, true);
            paramXMLHttpRequest.setRequestHeader("Content-Type", "application/json");
            
            var vData = JSON.stringify(paramUserObject);
            paramXMLHttpRequest.send(vData);
        }
        // Xử lý kết quả trả về
        function xuLyKetQuaTraVe(paramXMLHttpRequest) {
            var vRegisterInfo = paramXMLHttpRequest.responseText;
            console.log(vRegisterInfo);
        }
    </script>
</body>

</html>